from view import View
from vector import Vector
import math

class Camera(View):
    def __init__(self):
        View.__init__(self, Vector(0, 0, 0))
        self.around = 0
        self.updown = 0
        self.zoom = 15

    def change(self, x, y, z):
        self.around += y
        self.updown += x
        if self.updown > math.pi / 2: self.updown = math.pi / 2
        if self.updown < -math.pi / 2: self.updown = -math.pi / 2

        self.zoom += z
        if self.zoom < 5: self.zoom = 5
        if self.zoom > 20: self.zoom = 20

    def recalculate(self, target):
        #a = math.atan2(-back.x, back.z)
        p = Vector(0, 0, self.zoom)
        p = p.rotate(Vector(1, 0, 0), self.updown)
        p = p.rotate(Vector(0, 1, 0), self.around)

        self.b = p.normalize()
        self.r = -self.b.cross(Vector(0, 1, 0)).normalize()
        self.u = self.b.cross(self.r)

        self.position = target + p

        #self.b = Vector(0, 0, 1)
        #self.u = Vector(0, 1, 0)
        #self.r = Vector(1, 0, 0)
        #self.position = target + self.b * 1000
